/* if you're going to add new attributes, use numbers 1000 and up. that way
 * you won't have to go to renumbering pains when upgrading. */
#define OSEE AF_OSEE
#define SDARK AF_DARK
#define WIZARD AF_WIZARD
#define UNIMP AF_UNIMP
#define NOMOD AF_NOMOD
#define DATE AF_DATE
#define INH AF_INHERIT
#define LOCK AF_LOCK
#define FUNC AF_FUNC
#ifdef USE_SPACE
#define SPACE AF_SPACE
#endif
DOATTR(A_OSUCC,		  "Osucc",	     INH,			1)
DOATTR(A_OFAIL,		  "Ofail",	     INH,			2)
DOATTR(A_FAIL,		  "Fail",	     INH,			3)
DOATTR(A_SUCC,		  "Succ",	     INH,			4)
DOATTR(A_PASS,		  "Xyxxy",	     WIZARD|SDARK,		5)
DOATTR(A_DESC,		  "Desc",	     INH,			6)
DOATTR(A_SEX,		  "Sex",	     INH|OSEE,			7)
DOATTR(A_ODROP,		  "Odrop",	     INH,			8)
DOATTR(A_DROP,		  "Drop",	     INH,			9)
DOATTR(A_OKILL,		  "Okill",	     INH,			10)
DOATTR(A_KILL,		  "Kill",	     INH,			11)
DOATTR(A_ASUCC,		  "Asucc",	     INH,			12)
DOATTR(A_AFAIL,		  "Afail",	     INH,			13)
DOATTR(A_ADROP,		  "Adrop",	     INH,			14)
DOATTR(A_AKILL,		  "Akill",	     INH,			15)
DOATTR(A_DOES,		  "Does",	     INH,			16)
DOATTR(A_CHARGES,	  "Charges",	     INH,			17)
DOATTR(A_RUNOUT,	  "Runout",	     INH,			18)
DOATTR(A_STARTUP,	  "Startup",	     INH|WIZARD,		19)
DOATTR(A_ACLONE,	  "Aclone",	     INH,			20)
DOATTR(A_APAY,		  "Apay",	     INH,			21)
DOATTR(A_OPAY,		  "Opay",	     INH,			22)
DOATTR(A_PAY,		  "Pay",	     INH,			23)
DOATTR(A_COST,		  "Cost",	     INH,			24)
DOATTR(A_LISTEN,	  "Listen",	     INH,			26)
DOATTR(A_AAHEAR,	  "Aahear",	     INH,			27)
DOATTR(A_AMHEAR,	  "Amhear",	     INH,			28)
DOATTR(A_AHEAR,		  "Ahear",	     INH,			29)
DOATTR(A_LAST,		  "Last",	     WIZARD|DATE|OSEE,		30)
DOATTR(A_QUEUE,		  "Queue",	     WIZARD|UNIMP,		31)
DOATTR(A_IDESC,		  "Idesc",	     INH,			32)
DOATTR(A_ENTER,		  "Enter",	     INH,			33)
DOATTR(A_OENTER,	  "Oenter",	     INH,			34)
DOATTR(A_AENTER,	  "Aenter",	     INH,			35)
DOATTR(A_ADESC,		  "Adesc",	     INH,			36)
DOATTR(A_ODESC,		  "Odesc",	     INH,			37)
DOATTR(A_RQUOTA,	  "Rquota",	     SDARK|NOMOD|WIZARD,		38)
DOATTR(A_IDLE,		  "Idle",	     SDARK|WIZARD,		39)
DOATTR(A_AWAY,		  "Away",	     SDARK|WIZARD,		40)
DOATTR(A_MAILK,		  "Mailk",	     SDARK|NOMOD|WIZARD|UNIMP,	41)
DOATTR(A_ALIAS,		  "Alias",	     OSEE,			42)
DOATTR(A_EFAIL,		  "Efail",	     INH,			43)
DOATTR(A_OEFAIL,	  "Oefail",	     INH,			44)
DOATTR(A_AEFAIL,	  "Aefail",	     INH,			45)
DOATTR(A_IT,		  "It",		     UNIMP,			46)
DOATTR(A_LEAVE,		  "Leave",	     INH,			47)
DOATTR(A_OLEAVE,	  "Oleave",	     INH,			48)
DOATTR(A_ALEAVE,	  "Aleave",	     INH,			49)
DOATTR(A_CHANNEL,	  "Channel",	     WIZARD,			50)
DOATTR(A_QUOTA,		  "Quota",	     SDARK|NOMOD|UNIMP|WIZARD,	51)
DOATTR(A_PENNIES,	  "Pennies",	     WIZARD|SDARK|NOMOD,		52)
DOATTR(A_HUHTO,		  "Huhto",	     WIZARD,			53)
DOATTR(A_HAVEN,		  "Haven",	     WIZARD|SDARK,		54)
DOATTR(A_ALOGIN,	  "Alogin",	     INH,			55)
DOATTR(A_ALOGOUT,	  "Alogout",	     INH,			56)
DOATTR(A_TZ,		  "TZ",		     INH,			57)
DOATTR(A_DOOMSDAY,	  "Doomsday",	     WIZARD,			58)
#ifdef EMAIL_CREATE
DOATTR(A_EMAIL,		  "Email",	     WIZARD,			59)
#endif
#ifdef USE_SPACE
DOATTR(A_ASHIP,		  "Aship",	     SPACE|INH,			60)
DOATTR(A_SECTOR,	  "Sector",	     SPACE,			61)
DOATTR(A_MASS,		  "Mass",	     SPACE,			62)
DOATTR(A_RADIUS,	  "Radius",	     SPACE,			63)
DOATTR(A_THRUST,	  "Thrust",	     SPACE,			64)
DOATTR(A_RATING,	  "Rating",	     SPACE,			65)
DOATTR(A_EFFICIENCY,	  "Efficiency",	     SPACE,			66)
DOATTR(A_FUEL,		  "Fuel",	     SPACE,			67)
DOATTR(A_ACCELERATION,	  "Acceleration",    SPACE,			68)
DOATTR(A_VISMULT,	  "Vismult",	     SPACE,			69)
DOATTR(A_PWRGEN,	  "Pwrgen",	     SPACE,			70)
DOATTR(A_PWRFUEL,	  "Pwrfuel",	     SPACE,			71)
DOATTR(A_SPRSTR,	  "SprStr",	     SPACE,			72)
DOATTR(A_HULL,		  "Hull",	     SPACE,			73)
DOATTR(A_RECOVER,	  "Recover",	     SPACE|SDARK|NOMOD,		74)
DOATTR(A_TYPE,		  "Type",	     SPACE|OSEE,		75)
DOATTR(A_ENERGY,	  "Energy",	     SPACE|UNIMP,		76)
DOATTR(A_LINPOSX,	  "LinposX",	     SPACE|UNIMP,		80)
DOATTR(A_LINPOSY,	  "LinposY",	     SPACE|UNIMP,		81)
DOATTR(A_LINPOSZ,	  "LinposZ",	     SPACE|UNIMP,		82)
DOATTR(A_LINVELX,	  "LinvelX",	     SPACE|UNIMP,		83)
DOATTR(A_LINVELY,	  "LinvelY",	     SPACE|UNIMP,		84)
DOATTR(A_LINVELZ,	  "LinvelZ",	     SPACE|UNIMP,		85)
DOATTR(A_LINACCX,	  "LinaccX",	     SPACE|UNIMP,		86)
DOATTR(A_LINACCY,	  "LinaccY",	     SPACE|UNIMP,		87)
DOATTR(A_LINACCZ,	  "LinaccZ",	     SPACE|UNIMP,		88)
DOATTR(A_ANGPOSX,	  "AngposX",	     SPACE,			89)
DOATTR(A_ANGPOSY,	  "AngposY",	     SPACE,			90)
DOATTR(A_ANGPOSZ,	  "AngposZ",	     SPACE,			91)
DOATTR(A_ANGVELX,	  "AngvelX",	     SPACE,			92)
DOATTR(A_ANGVELY,	  "AngvelY",	     SPACE,			93)
DOATTR(A_ANGVELZ,	  "AngvelZ",	     SPACE,			94)
DOATTR(A_ANGACCX,	  "AngaccX",	     SPACE|UNIMP,		95)
DOATTR(A_ANGACCY,	  "AngaccY",	     SPACE|UNIMP,		96)
DOATTR(A_ANGACCZ,	  "AngaccZ",	     SPACE|UNIMP,		97)
#endif
DOATTR(A_TALENT,	  "Talent",	     INH|OSEE,			98)
DOATTR(A_RACE,		  "Race",	     INH|WIZARD|OSEE,		99)
#ifndef DECLARE_ATTR
DOATTR(A_V[0],		  "Va",		     INH,			100+0)
DOATTR(A_V[1],		  "Vb",		     INH,			100+1)
DOATTR(A_V[2],		  "Vc",		     INH,			100+2)
DOATTR(A_V[3],		  "Vd",		     INH,			100+3)
DOATTR(A_V[4],		  "Ve",		     INH,			100+4)
DOATTR(A_V[5],		  "Vf",		     INH,			100+5)
DOATTR(A_V[6],		  "Vg",		     INH,			100+6)
DOATTR(A_V[7],		  "Vh",		     INH,			100+7)
DOATTR(A_V[8],		  "Vi",		     INH,			100+8)
DOATTR(A_V[9],		  "Vj",		     INH,			100+9)
DOATTR(A_V[10],		  "Vk",		     INH,			100+10)
DOATTR(A_V[11],		  "Vl",		     INH,			100+11)
DOATTR(A_V[12],		  "Vm",		     INH,			100+12)
DOATTR(A_V[13],		  "Vn",		     INH,			100+13)
DOATTR(A_V[14],		  "Vo",		     INH,			100+14)
DOATTR(A_V[15],		  "Vp",		     INH,			100+15)
DOATTR(A_V[16],		  "Vq",		     INH,			100+16)
DOATTR(A_V[17],		  "Vr",		     INH,			100+17)
DOATTR(A_V[18],		  "Vs",		     INH,			100+18)
DOATTR(A_V[19],		  "Vt",		     INH,			100+19)
DOATTR(A_V[20],		  "Vu",		     INH,			100+20)
DOATTR(A_V[21],		  "Vv",		     INH,			100+21)
DOATTR(A_V[22],		  "Vw",		     INH,			100+22)
DOATTR(A_V[23],		  "Vx",		     INH,			100+23)
DOATTR(A_V[24],		  "Vy",		     INH,			100+24)
DOATTR(A_V[25],		  "Vz",		     INH,			100+25)
#else /* declare_attr */
DOATTR(A_V[26],           "v attributes",    -1,                           -1);
#endif /* declare_attr */
DOATTR(A_MOVE,		  "Move",	     INH,			126)
DOATTR(A_OMOVE,		  "Omove",	     INH,			127)
DOATTR(A_AMOVE,		  "Amove",	     INH,			128)
DOATTR(A_LOCK,		  "Lock",	     LOCK,			129)
DOATTR(A_ELOCK,		  "Elock",	     LOCK,			130)
DOATTR(A_ULOCK,		  "Ulock",	     LOCK,			131)
DOATTR(A_UFAIL,		  "Ufail",	     INH,			132)
DOATTR(A_OUFAIL,	  "Oufail",	     INH,			133)
DOATTR(A_AUFAIL,	  "Aufail",	     INH,			134)
DOATTR(A_OCONN,		  "Oconnect",	     INH,			135)
DOATTR(A_ACONN,		  "Aconnect",	     INH,			136)
DOATTR(A_ODISC,		  "Odisconnect",     INH,			137)
DOATTR(A_ADISC,		  "Adisconnect",     INH,			138)
DOATTR(A_COLUMNS,	  "Columns",	     INH,			139)
DOATTR(A_WHOFLAGS,	  "who_flags",	     INH,			140)
DOATTR(A_WHONAMES,	  "who_names",	     INH,			141)
DOATTR(A_APAGE,		  "Apage",	     INH,			142)
DOATTR(A_APEMIT,	  "Apemit",	     INH,			143)
DOATTR(A_AWHISPER,	  "Awhisper",	     INH,			144)
#ifdef USE_SPACE
DOATTR(A_S0,		  "S0",		     SPACE,			145+0)
DOATTR(A_S1,		  "S1",		     SPACE,			145+1)
DOATTR(A_S2,		  "S2",		     SPACE,			145+2)
DOATTR(A_S3,		  "S3",		     SPACE,			145+3)
DOATTR(A_S4,		  "S4",		     SPACE,			145+4)
DOATTR(A_S5,		  "S5",		     SPACE,			145+5)
DOATTR(A_S6,		  "S6",		     SPACE,			145+6)
DOATTR(A_S7,		  "S7",		     SPACE,			145+7)
DOATTR(A_S8,		  "S8",		     SPACE,			145+8)
DOATTR(A_S9,		  "S9",		     SPACE,			145+9)
#endif
DOATTR(A_USE,		  "Use",	     INH,			155)
DOATTR(A_OUSE,		  "OUse",	     INH,			156)
DOATTR(A_AUSE,		  "AUse",	     INH,			157)
DOATTR(A_LHIDE,		  "LHide",	     LOCK,			158)
DOATTR(A_LPAGE,		  "LPage",	     LOCK,			159)
DOATTR(A_LLOCK,		  "Llock",	     LOCK,			161)
DOATTR(A_LFAIL,		  "Lfail",	     INH,			162)
DOATTR(A_OLFAIL,	  "Olfail",	     INH,			163)
DOATTR(A_ALFAIL,	  "Alfail",	     INH,			164)
DOATTR(A_SLOCK,		  "Slock",	     LOCK,			165)
DOATTR(A_SFAIL,		  "Sfail",	     INH,			166)
DOATTR(A_OSFAIL,	  "Osfail",	     INH,			167)
DOATTR(A_ASFAIL,	  "Asfail",	     INH,			168)
DOATTR(A_DOING,		  "Doing",	     INH|OSEE,			169)
DOATTR(A_USERS,		  "Users",	     INH|WIZARD,		170)
DOATTR(A_DEFOWN,	  "Defown",	     INH,			171)
DOATTR(A_WARNINGS,	  "Warnings",	     INH,			172)
DOATTR(A_WINHIBIT,	  "WInhibit",	     INH,			173)
DOATTR(A_ANEWS,		  "ANews",	     INH,			174)
#undef OSEE
#undef SDARK
#undef WIZARD
#undef UNIMP
#undef NOMOD
#undef DATE
#undef INH
#undef LOCK
#undef FUNC
#ifdef USE_SPACE
#undef SPACE
#endif
